#include <cstdio>
#include <cctype>
#include <algorithm>
#include "binding.hh"

static char DefVarType[26+1] = "!!!!!!!!!!!!!!!!!!!!!!!!!!";

void SetDefVarType(char begin, char end, char type)
{
    begin = std::toupper(begin);
    end   = std::toupper(end);
    
    if(begin > end) { std::swap(begin, end); }
    
    /* TODO */
    fprintf(stderr, "DEF-%c characters %c-%c\n", type, begin, end);
    
    while(begin<=end)
        DefVarType[begin++ - 'A'] = type;
}

void SetMetaDynamic()
{
    fprintf(stderr, "Meta $DYNAMIC\n");
}

void SetMetaStatic()
{
    fprintf(stderr, "Meta $STATIC\n");
}

char HasTypeSuffix(const std::string& varname)
{
    if(varname.empty()) return 0;
    char lastchar = varname[varname.size() - 1];
    switch(lastchar)
    {
        case '%':
        case '!':
        case '&':
        case '#':
        case '$': return lastchar;
    }
    return 0;
}

long double DeclareAsLabelInCurrentScope(const std::string& varname)
{
    return 0.1;
}

unsigned TranslateLabelToDataPtr(const long double l)
{
    return 0;
}
